USE master
GO

sp_configure 'show advanced options', 1 ;
GO
RECONFIGURE ;
GO
-- 10 seconds
sp_configure 'blocked process threshold',10 ;
GO
RECONFIGURE ;
GO

USE pubs
GO

create queue blockq
GO
create service blockservice
 on queue blockq
 ([http://schemas.microsoft.com/SQL/Notifications/PostEventNotification])
GO

create event notification blocknot
 on server 
 for Blocked_Process_Report
 to service 'blockservice', 'current database'
GO

-- go to blocker/blockee and create 'em

-- read 'em
select convert(xml,message_body) from blockq


-- or postprocess the information
DECLARE @T TABLE (thereport xml);

-- receive these into table variable
RECEIVE convert(xml,message_body) 
FROM blockq
INTO @T

SELECT  
 Tab.Col.value('(./blocked-process/process/@spid)[1]','nvarchar(50)') AS  'BlockedSPID',
 Tab.Col.value('(./blocked-process/process/inputbuf)[1]','nvarchar(4000)') AS 'Blocked Input Buffer',
 Tab.Col.value('(./blocking-process/process/@spid)[1]','nvarchar(50)') AS  'BlockingSPID',
 Tab.Col.value('(./blocking-process/process/inputbuf)[1]','nvarchar(50)') AS  'Blocking Input Buffer'
FROM @T
CROSS APPLY
 thereport.nodes('/EVENT_INSTANCE/TextData/blocked-process-report') AS Tab(Col)

