using System;
using System.IO;
using System.Data;
using System.Data.Sql;
using System.Data.SqlClient;

public partial class xmlshowplanaccess 
{
    public static void GetXMLShowplanCost(string tsqlStmt, ref string tsqlStmtShowplan) 
    {
        // tsqlStmt contains the statement whose showplan needs to be returned
        // tsqlStmtShowplan will return the showplan of tsqlStmt in XML format

        // Open a connection and create a command
        SqlConnection conn = new SqlConnection("context connection = true");
        conn.Open();
        SqlCommand cmd = conn.CreateCommand();

        cmd.CommandText = "set showplan_xml on";
        cmd.ExecuteNonQuery();  // turn the showplan_xml mode on
        cmd.CommandText = tsqlStmt;
        try 
        {
            // thePlan will contain the showplan in XML format
            String thePlan = String.Empty;
            SqlDataReader sdr = cmd.ExecuteReader();
            // In case the result set is chunked, concatenate
            while (sdr.Read()) 
                thePlan += sdr.GetSqlString(0).ToString();
            sdr.Close();
            cmd.CommandText = "set showplan_xml off" ;
            cmd.ExecuteNonQuery();  // turn the showplan_xml mode off
            tsqlStmtShowplan = thePlan;  // return the showplan in XML format
        } 
        catch (SqlException e) // return well formed xml document with the text of exception
        {
            tsqlStmtShowplan = "<error>" + e.ToString() + "</error>";
        }
    }  // GetXMLShowplan ends
}  // xmlshowplanaccess ends