
USE tempdb
GO

-- populate an XML schema collection with showplan schema
DECLARE @x XML
SET @X = (
  SELECT * FROM Openrowset( 
    BULK 'C:\ITForum\DAT304_XMLDBA\XMLDBA\showplanxml.xsd', SINGLE_BLOB) AS A
)

CREATE XML SCHEMA COLLECTION dbo.showplan_schema AS @x
GO

DECLARE @showplan XML(dbo.showplan_schema)
SET @showplan = 
'<ShowPlanXML xmlns="http://schemas.microsoft.com/sqlserver/2004/07/showplan" Version="0.5" Build="9.00.938">
  <BatchSequence>
    <Batch>
      <Statements>
        <StmtSimple StatementText="SELECT * FROM t WHERE b &gt; 100 AND (c &gt; 10 OR d = 10)" StatementId="1" StatementCompId="1" StatementType="SELECT" StatementSubTreeCost="0.0355863" StatementEstRows="1" StatementOptmLevel="FULL">
          <StatementSetOptions QUOTED_IDENTIFIER="true" ARITHABORT="true" CONCAT_NULL_YIELDS_NULL="true" ANSI_NULLS="true" ANSI_PADDING="true" ANSI_WARNINGS="true" NUMERIC_ROUNDABORT="false" />
          <QueryPlan CachedPlanSize="48">
            <RelOp NodeId="0" PhysicalOp="Filter" LogicalOp="Filter" EstimateRows="1" EstimateIO="0" EstimateCPU="4.8e-007" AvgRowSize="35" EstimatedTotalSubtreeCost="0.0355863" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
              <OutputList>
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="g" />
              </OutputList>
              <Filter StartupExpression="0">
                <RelOp NodeId="1" PhysicalOp="Nested Loops" LogicalOp="Inner Join" EstimateRows="1" EstimateIO="0" EstimateCPU="4.18e-006" AvgRowSize="35" EstimatedTotalSubtreeCost="0.0355858" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                  <OutputList>
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="g" />
                  </OutputList>
                  <NestedLoops Optimized="0">
                    <OuterReferences>
                      <ColumnReference Column="Uniq1002" />
                      <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                      <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                      <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                      <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                      <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                      <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                    </OuterReferences>
                    <RelOp NodeId="2" PhysicalOp="Stream Aggregate" LogicalOp="Aggregate" EstimateRows="1" EstimateIO="0" EstimateCPU="3e-006" AvgRowSize="35" EstimatedTotalSubtreeCost="0.0291735" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                      <OutputList>
                        <ColumnReference Column="Uniq1002" />
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                      </OutputList>
                      <StreamAggregate>
                        <DefinedValues />
                        <GroupBy>
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                          <ColumnReference Column="Uniq1002" />
                          <ColumnReference Column="IsBaseRow1001" />
                        </GroupBy>
                        <RelOp NodeId="3" PhysicalOp="Sort" LogicalOp="Sort" EstimateRows="2" EstimateIO="0.01625" EstimateCPU="0.000103156" AvgRowSize="36" EstimatedTotalSubtreeCost="0.0291705" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                          <OutputList>
                            <ColumnReference Column="IsBaseRow1001" />
                            <ColumnReference Column="Uniq1002" />
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                          </OutputList>
                          <MemoryFractions Input="1" Output="1" />
                          <Sort Distinct="0">
                            <OrderBy>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                              </OrderByColumn>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                              </OrderByColumn>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                              </OrderByColumn>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                              </OrderByColumn>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                              </OrderByColumn>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                              </OrderByColumn>
                              <OrderByColumn Ascending="1">
                                <ColumnReference Column="Uniq1002" />
                              </OrderByColumn>
                            </OrderBy>
                            <RelOp NodeId="4" PhysicalOp="Concatenation" LogicalOp="Concatenation" EstimateRows="2" EstimateIO="0" EstimateCPU="2e-007" AvgRowSize="36" EstimatedTotalSubtreeCost="0.0128174" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                              <OutputList>
                                <ColumnReference Column="IsBaseRow1001" />
                                <ColumnReference Column="Uniq1002" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                              </OutputList>
                              <Concat>
                                <DefinedValues>
                                  <DefinedValue>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Column="Uniq1002" />
                                    <ColumnReference Column="Uniq1002" />
                                    <ColumnReference Column="Uniq1002" />
                                  </DefinedValue>
                                  <DefinedValue>
                                    <ColumnReference Column="IsBaseRow1001" />
                                    <ColumnReference Column="IsBaseRow1001" />
                                    <ColumnReference Column="IsBaseRow1001" />
                                  </DefinedValue>
                                </DefinedValues>
                                <RelOp NodeId="5" PhysicalOp="Index Seek" LogicalOp="Index Seek" EstimateRows="1" EstimateIO="0.00625" EstimateCPU="0.000158103" AvgRowSize="36" EstimatedTotalSubtreeCost="0.0064081" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                                  <OutputList>
                                    <ColumnReference Column="IsBaseRow1001" />
                                    <ColumnReference Column="Uniq1002" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                  </OutputList>
                                  <IndexScan Ordered="1" ScanDirection="FORWARD" ForcedIndex="0">
                                    <DefinedValues>
                                      <DefinedValue>
                                        <ColumnReference Column="IsBaseRow1001" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Column="Uniq1002" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                      </DefinedValue>
                                    </DefinedValues>
                                    <Object Database="[tempdb]" Schema="[dbo]" Table="[t]" Index="idx2" />
                                    <SeekPredicates>
                                      <SeekPredicate>
                                        <StartRange ScanType="GT">
                                          <RangeColumns>
                                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                          </RangeColumns>
                                          <RangeExpressions>
                                            <ScalarOperator ScalarString="(10)">
                                              <Const ConstValue="(10)" />
                                            </ScalarOperator>
                                          </RangeExpressions>
                                        </StartRange>
                                      </SeekPredicate>
                                    </SeekPredicates>
                                    <Predicate>
                                      <ScalarOperator ScalarString="[tempdb].[dbo].[t].[b]&gt;(100)">
                                        <Compare CompareOp="GT">
                                          <ScalarOperator>
                                            <Identifier>
                                              <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                            </Identifier>
                                          </ScalarOperator>
                                          <ScalarOperator>
                                            <Const ConstValue="(100)" />
                                          </ScalarOperator>
                                        </Compare>
                                      </ScalarOperator>
                                    </Predicate>
                                  </IndexScan>
                                </RelOp>
                                <RelOp NodeId="6" PhysicalOp="Index Seek" LogicalOp="Index Seek" EstimateRows="1" EstimateIO="0.00625" EstimateCPU="0.000158103" AvgRowSize="36" EstimatedTotalSubtreeCost="0.0064081" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                                  <OutputList>
                                    <ColumnReference Column="IsBaseRow1001" />
                                    <ColumnReference Column="Uniq1002" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                  </OutputList>
                                  <IndexScan Ordered="1" ScanDirection="FORWARD" ForcedIndex="0">
                                    <DefinedValues>
                                      <DefinedValue>
                                        <ColumnReference Column="IsBaseRow1001" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Column="Uniq1002" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                      </DefinedValue>
                                      <DefinedValue>
                                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                      </DefinedValue>
                                    </DefinedValues>
                                    <Object Database="[tempdb]" Schema="[dbo]" Table="[t]" Index="idx3" />
                                    <SeekPredicates>
                                      <SeekPredicate>
                                        <Prefix ScanType="EQ">
                                          <RangeColumns>
                                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                          </RangeColumns>
                                          <RangeExpressions>
                                            <ScalarOperator ScalarString="(10)">
                                              <Const ConstValue="(10)" />
                                            </ScalarOperator>
                                          </RangeExpressions>
                                        </Prefix>
                                      </SeekPredicate>
                                    </SeekPredicates>
                                    <Predicate>
                                      <ScalarOperator ScalarString="[tempdb].[dbo].[t].[b]&gt;(100)">
                                        <Compare CompareOp="GT">
                                          <ScalarOperator>
                                            <Identifier>
                                              <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                            </Identifier>
                                          </ScalarOperator>
                                          <ScalarOperator>
                                            <Const ConstValue="(100)" />
                                          </ScalarOperator>
                                        </Compare>
                                      </ScalarOperator>
                                    </Predicate>
                                  </IndexScan>
                                </RelOp>
                              </Concat>
                            </RelOp>
                          </Sort>
                        </RelOp>
                      </StreamAggregate>
                    </RelOp>
                    <RelOp NodeId="9" PhysicalOp="Clustered Index Seek" LogicalOp="Clustered Index Seek" EstimateRows="1" EstimateIO="0.00625" EstimateCPU="0.000158122" AvgRowSize="11" EstimatedTotalSubtreeCost="0.00640812" Parallel="0" EstimateRebinds="0" EstimateRewinds="0">
                      <OutputList>
                        <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="g" />
                      </OutputList>
                      <IndexScan Ordered="1" ScanDirection="FORWARD" ForcedIndex="0">
                        <DefinedValues>
                          <DefinedValue>
                            <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="g" />
                          </DefinedValue>
                        </DefinedValues>
                        <Object Database="[tempdb]" Schema="[dbo]" Table="[t]" Index="cidx" />
                        <SeekPredicates>
                          <SeekPredicate>
                            <Prefix ScanType="EQ">
                              <RangeColumns>
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                <ColumnReference Column="Uniq1002" />
                              </RangeColumns>
                              <RangeExpressions>
                                <ScalarOperator ScalarString="[tempdb].[dbo].[t].[a]">
                                  <Identifier>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="a" />
                                  </Identifier>
                                </ScalarOperator>
                                <ScalarOperator ScalarString="[tempdb].[dbo].[t].[b]">
                                  <Identifier>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                                  </Identifier>
                                </ScalarOperator>
                                <ScalarOperator ScalarString="[tempdb].[dbo].[t].[c]">
                                  <Identifier>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="c" />
                                  </Identifier>
                                </ScalarOperator>
                                <ScalarOperator ScalarString="[tempdb].[dbo].[t].[d]">
                                  <Identifier>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="d" />
                                  </Identifier>
                                </ScalarOperator>
                                <ScalarOperator ScalarString="[tempdb].[dbo].[t].[e]">
                                  <Identifier>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="e" />
                                  </Identifier>
                                </ScalarOperator>
                                <ScalarOperator ScalarString="[tempdb].[dbo].[t].[f]">
                                  <Identifier>
                                    <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="f" />
                                  </Identifier>
                                </ScalarOperator>
                                <ScalarOperator ScalarString="[Uniq1002]">
                                  <Identifier>
                                    <ColumnReference Column="Uniq1002" />
                                  </Identifier>
                                </ScalarOperator>
                              </RangeExpressions>
                            </Prefix>
                          </SeekPredicate>
                        </SeekPredicates>
                      </IndexScan>
                    </RelOp>
                  </NestedLoops>
                </RelOp>
                <Predicate>
                  <ScalarOperator ScalarString="[tempdb].[dbo].[t].[b]&gt;(100)">
                    <Compare CompareOp="GT">
                      <ScalarOperator>
                        <Identifier>
                          <ColumnReference Database="[tempdb]" Schema="[dbo]" Table="[t]" Column="b" />
                        </Identifier>
                      </ScalarOperator>
                      <ScalarOperator>
                        <Const ConstValue="(100)" />
                      </ScalarOperator>
                    </Compare>
                  </ScalarOperator>
                </Predicate>
              </Filter>
            </RelOp>
          </QueryPlan>
        </StmtSimple>
      </Statements>
    </Batch>
  </BatchSequence>
</ShowPlanXML>'