-- ===========================
-- Create Endpoint Template
-- ===========================
USE pubs
GO

---------------------------------------------------------------------------- 
-- First create a stored procedure that will be exposed as a web service
---------------------------------------------------------------------------- 
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'hello_world' 
)
   DROP PROCEDURE dbo.hello_world
GO

CREATE PROCEDURE dbo.hello_world
	(@msg NVARCHAR(256))
AS 
	SELECT @msg AS message
GO

sp_reserve_http_namespace N'http://*:80/sql/hello_world'
GO

---------------------------------------------------------------------------- 
-- Then, create the HTTP endpoint to expose hello_world_proc as a webmethod
---------------------------------------------------------------------------- 
IF EXISTS (
	SELECT name from sys.http_endpoints 
	WHERE name = N'pubs'
)
	DROP ENDPOINT pubs
GO

CREATE ENDPOINT pubs
	STATE = STARTED
	AS HTTP (
		path='/sql/hello_world',
		AUTHENTICATION=(INTEGRATED),
		PORTS = (CLEAR)
	)
	FOR SOAP(
		WEBMETHOD 'http://tempuri.org/' . 'hello_world' (NAME = 'pubs.dbo.hello_world' ),
		WSDL = DEFAULT,
		BATCHES=ENABLED
	)
GO

DROP ENDPOINT pubs;
GO

